package cs3500.tictactoe.strategy;

import cs3500.tictactoe.model.Piece;
import cs3500.tictactoe.model.TicTacToeModel;

public class PlayToCornerStrategy implements PosnStrategy {

  private final PosnStrategy backupPlan;

  public PlayToCornerStrategy(PosnStrategy backupPlan) {
    this.backupPlan = backupPlan;
  }

  @Override
  public Posn choosePosn(TicTacToeModel model, Piece player) {
    int width = model.getWidth();
    int height = model.getHeight();
    Posn[] corners = new Posn[]{
            new Posn(0, 0),
            new Posn(width - 1, 0),
            new Posn(0, height - 1),
            new Posn(width - 1, height - 1)
    };
    for (Posn p : corners) {
      if (model.getPieceAt(p.r, p.c) == Piece.EMPTY) {
        return p;
      }
    }
    return backupPlan.choosePosn(model, player);
  }
}
