package cs3500.tictactoe.strategy;

import cs3500.tictactoe.model.Piece;
import cs3500.tictactoe.model.TicTacToeModel;

public class StrategyFallback implements PosnStrategy {
  private final PosnStrategy tryFirst, trySecond;

  public StrategyFallback(PosnStrategy tryFirst, PosnStrategy trySecond) {
    this.tryFirst = tryFirst;
    this.trySecond = trySecond;
  }

  @Override
  public Posn choosePosn(TicTacToeModel model, Piece player) {
    Posn ans = this.tryFirst.choosePosn(model, player);
    if (ans != null) { return ans; }
    return this.trySecond.choosePosn(model, player);
  }
}
